// Projeto usando Timer0 TMR0 (modo 16 bits) para piscar LED a cada 1 segundo

     // Uso do PORTD.RD0 = LED

     // Ciclo de Mquina = Fosc/4 = 8 MHz / 4 = 0.5 us


// time_overflow = ciclo de maq. * prescaler * (modo_8_16_bits - valor inicial)
     // Para 1 segundo:

     // 1000.000us = 0.5 us * 128 *  (65536-x)
                     // 128 = prescalar adotado segundo datasheet
    //  1000.000/(0.5 * 128) = 65536 - x

// x = 65536 - 15625 = 49911 (valor inicial carregado nos registradores do timer0)
    // 49911 = C2F7h (em hexadecimal) = HByte: C2; LByte: F7

    // TMR0L = 0xF7;
    // TMR0H = 0xC2;


// Tempo mximo de contagem com TMR0 usando prescaler (razo max = 256)
// time_max = 0.5 *256 * 65536 = 8.388.608us -> ~8.4s
 //*****************************************************************************

// Programao do TMR0:   (ver datasheet e material de aula)

//   T0CON = 0B00000110;  inicialmente desligado, opera como timer, uso do clock
//  no usa borda, uso do prescaler (ativo em 0), e razo do prescaler: 110 (128)

    // TMR0L = 0xF7;
    // TMR0H = 0xC2;
//  INTCON.TMR0IF = 0 ; Flag de overflow do timer0 no registrador INTCON

// T0CON.TMR0ON = 1; Liga do timer no registrador T0CON (MSB = 1)



void ConfigMCU()
{
  #ifdef P18F45K22
  ANSELD = 0;
  #else
  ADCON1 |= 0x0F;
  #endif

   TRISD = 0;    // PORTD (LEDS) como sada
   PORTD = 0;    // LED inicialmente OFF

}

void ConfigTIMER()
{
 // Programaao do TMR0

  T0CON = 0B00000110;  // inicialmente desligado, opera como timer, uso do clock
//  no usa borda, uso do prescaler (ativo em 0), e razo do prescaler: 110 (128)

   TMR0L = 0xF7;
   TMR0H = 0xC2;
   INTCON.TMR0IF = 0 ; //Flag de overflow do timer0 no registrador INTCON inicialmente zerada


   T0CON.TMR0ON = 1; //Liga do timer no registrador T0CON (MSB = 1)

}

void main() {

ConfigMCU();
ConfigTIMER();

while(1)
{
        if (INTCON.TMR0IF == 1)       // Se houve o "estouro" da contagem
        {
           PORTD.RD0 = ~LATD.RD0;  // inverte nvel lgico do LED

           // Recarrega o timer
            TMR0L = 0xF7;
            TMR0H = 0xC2;
            INTCON.TMR0IF = 0;    // zera o flag de overflow da contagem
        }


}

}